# 渠道云代码生成工具
使用代码生成工具，可以减少重复的CURD工作，有效提升开发效率，但是要注意代码生成工具生成代码时会覆盖指定生成目录下原有的同名文件，生成代码时请检查“TABLE_CODES”物理表名称参数值是否正确。

目前只支持生成web模块的代码，api模块的代码需要根据实际情况手动编写
## 1.工具原理
通过解析PDM数据库设计文件（PowerDesign工具生成），提取PDM中包表的相关属性信息，以ftl文件为模板生成对应的Entity、DTO、Mapper、MapperDecorator（可选）、Repository、Service、Controller，RefController（可选）类文件。
## 2.结构说明
- 入口函数类:occ-toolkit\src\main\java\com\yonyou\occ\codegenerator\CodeGeneratorEntry.java
- 模板文件：occ-toolkit\src\main\resources\generator\\*
## 3.入口参数
- 原顶级包路径：OLD_BASE_PACKAGE
- 新的顶级包路径：NEW_BASE_PACKAGE
- PDM文件路径：PDM_FILE
- 物理表名称（英文逗号分隔）：TABLE_CODES
- 参照类型（[空字符串], Grid, Tree, GridTree）：REFERENCE_TYPE
- 是否使用了自定义档案参照：IF_USE_CUST_DOC_DEF_REF
- 作者：AUTHOR
- 目标项目根路径：TARGET_PROJECT_ROOT_PATH
- 元数据参数（是否主业务对象 1：主业务对象）：IS_MAIN